bash completion: Group commands by arguments and options
[ganeti-local] / Makefile.am
1 # Ganeti makefile
2 # - Indent with tabs only.
3 # - Keep files sorted; one line per file.
4 # - Directories in lib/ must have their own *dir variable (see hypervisor).
5 # - All directories must be listed DIRS.
6 # - Use autogen.sh to generate Makefile.in and configure script.
7
8 # Automake doesn't export these variables before version 1.10.
9 abs_top_builddir = @abs_top_builddir@
10 abs_top_srcdir = @abs_top_srcdir@
11
12 # Use bash in order to be able to use pipefail
13 SHELL=/bin/bash
14
15 ACLOCAL_AMFLAGS = -I autotools
16 BUILD_BASH_COMPLETION = $(top_srcdir)/autotools/build-bash-completion
17 RUN_IN_TEMPDIR = $(top_srcdir)/autotools/run-in-tempdir
18 CHECK_PYTHON_CODE = $(top_srcdir)/autotools/check-python-code
19 CHECK_MAN = $(top_srcdir)/autotools/check-man
20 CHECK_VERSION = $(top_srcdir)/autotools/check-version
21 CHECK_NEWS = $(top_srcdir)/autotools/check-news
22 DOCPP = $(top_srcdir)/autotools/docpp
23 REPLACE_VARS_SED = autotools/replace_vars.sed
24 CONVERT_CONSTANTS = $(top_srcdir)/autotools/convert-constants
25
26 # Note: these are automake-specific variables, and must be named after
27 # the directory + 'dir' suffix
28 clientdir = $(pkgpythondir)/client
29 hypervisordir = $(pkgpythondir)/hypervisor
30 httpdir = $(pkgpythondir)/http
31 masterddir = $(pkgpythondir)/masterd
32 confddir = $(pkgpythondir)/confd
33 rapidir = $(pkgpythondir)/rapi
34 serverdir = $(pkgpythondir)/server
35 watcherdir = $(pkgpythondir)/watcher
36 impexpddir = $(pkgpythondir)/impexpd
37 utilsdir = $(pkgpythondir)/utils
38 toolsdir = $(pkglibdir)/tools
39 iallocatorsdir = $(pkglibdir)/iallocators
40 pytoolsdir = $(pkgpythondir)/tools
41 docdir = $(datadir)/doc/$(PACKAGE)
42
43 # Delete output file if an error occurred while building it
44 .DELETE_ON_ERROR:
45
46 HTOOLS_DIRS = \
47         htools \
48         htools/Ganeti \
49         htools/Ganeti/HTools \
50         htools/Ganeti/HTools/Program
51
52 DIRS = \
53         autotools \
54         daemons \
55         devel \
56         doc \
57         doc/examples \
58         doc/examples/hooks \
59         doc/examples/gnt-debug \
60         $(HTOOLS_DIRS) \
61         lib \
62         lib/client \
63         lib/build \
64         lib/confd \
65         lib/http \
66         lib/hypervisor \
67         lib/impexpd \
68         lib/masterd \
69         lib/rapi \
70         lib/server \
71         lib/tools \
72         lib/utils \
73         lib/watcher \
74         man \
75         qa \
76         test \
77         test/data \
78         tools
79
80 BUILDTIME_DIR_AUTOCREATE = \
81         scripts \
82         $(APIDOC_DIR) \
83         $(APIDOC_PY_DIR) \
84         $(APIDOC_HS_DIR) \
85         $(APIDOC_HS_DIR)/Ganeti $(APIDOC_HS_DIR)/Ganeti/HTools \
86         $(APIDOC_HS_DIR)/Ganeti/HTools/Program \
87         $(COVERAGE_DIR) \
88         $(COVERAGE_PY_DIR) \
89         $(COVERAGE_HS_DIR) \
90         .hpc
91
92 BUILDTIME_DIRS = \
93         $(BUILDTIME_DIR_AUTOCREATE) \
94         doc/html
95
96 DIRCHECK_EXCLUDE = \
97         $(BUILDTIME_DIRS) \
98         ganeti-[0-9]*.[0-9]*.[0-9]* \
99         doc/html/_*
100
101 all_dirfiles = $(addsuffix /.dir,$(DIRS) $(BUILDTIME_DIR_AUTOCREATE))
102
103 # some helper vars
104 COVERAGE_DIR = doc/coverage
105 COVERAGE_PY_DIR = $(COVERAGE_DIR)/py
106 COVERAGE_HS_DIR = $(COVERAGE_DIR)/hs
107 APIDOC_DIR = doc/api
108 APIDOC_PY_DIR = $(APIDOC_DIR)/py
109 APIDOC_HS_DIR = $(APIDOC_DIR)/hs
110
111 MAINTAINERCLEANFILES = \
112         $(docpng) \
113         $(maninput) \
114         doc/install-quick.rst \
115         doc/news.rst \
116         doc/upgrade.rst \
117         vcs-version
118
119 maintainer-clean-local:
120         rm -rf $(BUILDTIME_DIRS)
121
122 CLEANFILES = \
123         $(addsuffix /*.py[co],$(DIRS)) \
124         $(addsuffix /*.hi,$(HTOOLS_DIRS)) \
125         $(addsuffix /*.o,$(HTOOLS_DIRS)) \
126         $(all_dirfiles) \
127         $(PYTHON_BOOTSTRAP) \
128         epydoc.conf \
129         autotools/replace_vars.sed \
130         daemons/daemon-util \
131         daemons/ganeti-cleaner \
132         devel/upload \
133         doc/examples/bash_completion \
134         doc/examples/ganeti.initd \
135         doc/examples/ganeti-kvm-poweroff.initd \
136         doc/examples/ganeti.cron \
137         doc/examples/gnt-config-backup \
138         doc/examples/hooks/ipsec \
139         $(man_MANS) \
140         $(manhtml) \
141         tools/kvm-ifup \
142         stamp-srclinks \
143         $(nodist_pkgpython_PYTHON) \
144         $(HS_ALL_PROGS) $(HS_BUILT_SRCS) \
145         .hpc/*.mix htools/*.tix \
146         doc/hs-lint.html
147
148 # BUILT_SOURCES should only be used as a dependency on phony targets. Otherwise
149 # it'll cause the target to rebuild every time.
150 BUILT_SOURCES = \
151         ganeti \
152         stamp-srclinks \
153         lib/_autoconf.py \
154         lib/_vcsversion.py \
155         $(all_dirfiles) \
156         $(PYTHON_BOOTSTRAP)
157
158 nodist_pkgpython_PYTHON = \
159         lib/_autoconf.py \
160         lib/_vcsversion.py
161
162 noinst_PYTHON = \
163         lib/build/__init__.py \
164         lib/build/sphinx_ext.py
165
166 pkgpython_PYTHON = \
167         lib/__init__.py \
168         lib/asyncnotifier.py \
169         lib/backend.py \
170         lib/bdev.py \
171         lib/bootstrap.py \
172         lib/cli.py \
173         lib/cmdlib.py \
174         lib/compat.py \
175         lib/config.py \
176         lib/constants.py \
177         lib/daemon.py \
178         lib/errors.py \
179         lib/ht.py \
180         lib/jqueue.py \
181         lib/jstore.py \
182         lib/locking.py \
183         lib/luxi.py \
184         lib/mcpu.py \
185         lib/netutils.py \
186         lib/objects.py \
187         lib/opcodes.py \
188         lib/qlang.py \
189         lib/query.py \
190         lib/rpc.py \
191         lib/runtime.py \
192         lib/serializer.py \
193         lib/ssconf.py \
194         lib/ssh.py \
195         lib/storage.py \
196         lib/uidpool.py \
197         lib/workerpool.py
198
199 client_PYTHON = \
200         lib/client/__init__.py \
201         lib/client/gnt_backup.py \
202         lib/client/gnt_cluster.py \
203         lib/client/gnt_debug.py \
204         lib/client/gnt_group.py \
205         lib/client/gnt_instance.py \
206         lib/client/gnt_job.py \
207         lib/client/gnt_node.py \
208         lib/client/gnt_os.py
209
210 hypervisor_PYTHON = \
211         lib/hypervisor/__init__.py \
212         lib/hypervisor/hv_base.py \
213         lib/hypervisor/hv_chroot.py \
214         lib/hypervisor/hv_fake.py \
215         lib/hypervisor/hv_kvm.py \
216         lib/hypervisor/hv_lxc.py \
217         lib/hypervisor/hv_xen.py
218
219 rapi_PYTHON = \
220         lib/rapi/__init__.py \
221         lib/rapi/baserlib.py \
222         lib/rapi/client.py \
223         lib/rapi/client_utils.py \
224         lib/rapi/connector.py \
225         lib/rapi/rlib2.py
226
227 http_PYTHON = \
228         lib/http/__init__.py \
229         lib/http/auth.py \
230         lib/http/client.py \
231         lib/http/server.py
232
233 confd_PYTHON = \
234         lib/confd/__init__.py \
235         lib/confd/client.py \
236         lib/confd/querylib.py \
237         lib/confd/server.py
238
239 masterd_PYTHON = \
240         lib/masterd/__init__.py \
241         lib/masterd/instance.py
242
243 impexpd_PYTHON = \
244         lib/impexpd/__init__.py
245
246 watcher_PYTHON = \
247         lib/watcher/__init__.py \
248         lib/watcher/nodemaint.py \
249         lib/watcher/state.py
250
251 server_PYTHON = \
252         lib/server/__init__.py \
253         lib/server/confd.py \
254         lib/server/masterd.py \
255         lib/server/noded.py \
256         lib/server/rapi.py
257
258 pytools_PYTHON = \
259         lib/tools/__init__.py \
260         lib/tools/ensure_dirs.py
261
262 utils_PYTHON = \
263         lib/utils/__init__.py \
264         lib/utils/algo.py \
265         lib/utils/filelock.py \
266         lib/utils/hash.py \
267         lib/utils/io.py \
268         lib/utils/log.py \
269         lib/utils/mlock.py \
270         lib/utils/nodesetup.py \
271         lib/utils/process.py \
272         lib/utils/retry.py \
273         lib/utils/text.py \
274         lib/utils/wrapper.py \
275         lib/utils/x509.py
276
277 docrst = \
278         doc/admin.rst \
279         doc/design-2.0.rst \
280         doc/design-2.1.rst \
281         doc/design-2.2.rst \
282         doc/design-2.3.rst \
283         doc/design-htools-2.3.rst \
284         doc/design-2.4.rst \
285         doc/design-2.5.rst \
286         doc/design-draft.rst \
287         doc/design-oob.rst \
288         doc/design-cpu-pinning.rst \
289         doc/design-query2.rst \
290         doc/design-x509-ca.rst \
291         doc/design-http-server.rst \
292         doc/design-impexp2.rst \
293         doc/design-lu-generated-jobs.rst \
294         doc/design-multi-reloc.rst \
295         doc/design-network.rst \
296         doc/design-chained-jobs.rst \
297         doc/cluster-merge.rst \
298         doc/design-shared-storage.rst \
299         doc/devnotes.rst \
300         doc/glossary.rst \
301         doc/hooks.rst \
302         doc/iallocator.rst \
303         doc/index.rst \
304         doc/install-quick.rst \
305         doc/install.rst \
306         doc/locking.rst \
307         doc/move-instance.rst \
308         doc/news.rst \
309         doc/rapi.rst \
310         doc/security.rst \
311         doc/upgrade.rst \
312         doc/walkthrough.rst
313
314 HS_PROGS = htools/htools
315 HS_BIN_ROLES = hbal hscan hspace
316
317 HS_ALL_PROGS = $(HS_PROGS) htools/test
318 HS_PROG_SRCS = $(patsubst %,%.hs,$(HS_ALL_PROGS))
319 # we don't add -Werror by default
320 HFLAGS = -O -Wall -fwarn-monomorphism-restriction -fwarn-tabs -ihtools
321 # extra flags that can be overriden on the command line
322 HEXTRA =
323 # exclude options for coverage reports
324 HPCEXCL = --exclude Main --exclude Ganeti.HTools.QC \
325         --exclude Ganeti.Constants \
326         --exclude Ganeti.HTools.Version
327
328 HS_LIB_SRCS = \
329         htools/Ganeti/HTools/CLI.hs \
330         htools/Ganeti/HTools/Cluster.hs \
331         htools/Ganeti/HTools/Compat.hs \
332         htools/Ganeti/HTools/Container.hs \
333         htools/Ganeti/HTools/ExtLoader.hs \
334         htools/Ganeti/HTools/Group.hs \
335         htools/Ganeti/HTools/IAlloc.hs \
336         htools/Ganeti/HTools/Instance.hs \
337         htools/Ganeti/HTools/Loader.hs \
338         htools/Ganeti/HTools/Luxi.hs \
339         htools/Ganeti/HTools/Node.hs \
340         htools/Ganeti/HTools/PeerMap.hs \
341         htools/Ganeti/HTools/QC.hs \
342         htools/Ganeti/HTools/Rapi.hs \
343         htools/Ganeti/HTools/Simu.hs \
344         htools/Ganeti/HTools/Text.hs \
345         htools/Ganeti/HTools/Types.hs \
346         htools/Ganeti/HTools/Utils.hs \
347         htools/Ganeti/HTools/Program/Hail.hs \
348         htools/Ganeti/HTools/Program/Hbal.hs \
349         htools/Ganeti/HTools/Program/Hscan.hs \
350         htools/Ganeti/HTools/Program/Hspace.hs \
351         htools/Ganeti/Jobs.hs \
352         htools/Ganeti/Luxi.hs \
353         htools/Ganeti/OpCodes.hs
354
355 HS_BUILT_SRCS = htools/Ganeti/HTools/Version.hs htools/Ganeti/Constants.hs
356 HS_BUILT_SRCS_IN = $(patsubst %,%.in,$(HS_BUILT_SRCS))
357
358 $(RUN_IN_TEMPDIR): | $(all_dirfiles)
359
360 # Note: we use here an order-only prerequisite, as the contents of
361 # _autoconf.py are not actually influencing the html build output: it
362 # has to exist in order for the sphinx module to be loaded
363 # successfully, but we certainly don't want the docs to be rebuilt if
364 # it changes
365 doc/html/index.html: $(docrst) $(docpng) doc/conf.py configure.ac \
366         $(RUN_IN_TEMPDIR) lib/build/sphinx_ext.py lib/opcodes.py lib/ht.py \
367         | lib/_autoconf.py lib/_vcsversion.py
368         @test -n "$(SPHINX)" || \
369             { echo 'sphinx-build' not found during configure; exit 1; }
370         @mkdir_p@ $(dir $@)
371         PYTHONPATH=. $(RUN_IN_TEMPDIR) $(SPHINX) -q -W -b html \
372             -d . \
373             -D version="$(VERSION_MAJOR).$(VERSION_MINOR)" \
374             -D release="$(PACKAGE_VERSION)" \
375             $(abs_top_srcdir)/doc $(CURDIR)/doc/html
376         rm -f doc/html/.buildinfo doc/html/objects.inv
377         touch $@
378
379 doc/html: doc/html/index.html
380
381 doc/install-quick.rst: INSTALL
382 doc/news.rst: NEWS
383 doc/upgrade.rst: UPGRADE
384
385 doc/install-quick.rst doc/news.rst doc/upgrade.rst:
386         set -e; \
387         { echo '.. This file is automatically updated at build time from $<.'; \
388           echo '.. Do not edit.'; \
389           echo; \
390           cat $<; \
391         } > $@
392
393 docdot = \
394         doc/arch-2.0.dot \
395         doc/design-2.1-lock-acquire.dot \
396         doc/design-2.1-lock-release.dot
397
398 docpng = $(patsubst %.dot,%.png,$(docdot))
399
400 # Things to build but not to install (add it to EXTRA_DIST if it should be
401 # distributed)
402 noinst_DATA = \
403         devel/upload \
404         doc/html \
405         doc/examples/bash_completion \
406         doc/examples/ganeti.cron \
407         doc/examples/ganeti.initd \
408         doc/examples/ganeti-kvm-poweroff.initd \
409         doc/examples/gnt-config-backup \
410         doc/examples/hooks/ipsec \
411         $(manhtml)
412
413 gnt_scripts = \
414         scripts/gnt-backup \
415         scripts/gnt-cluster \
416         scripts/gnt-debug \
417         scripts/gnt-group \
418         scripts/gnt-instance \
419         scripts/gnt-job \
420         scripts/gnt-node \
421         scripts/gnt-os
422
423 PYTHON_BOOTSTRAP_SBIN = \
424         daemons/ganeti-confd \
425         daemons/ganeti-masterd \
426         daemons/ganeti-noded \
427         daemons/ganeti-watcher \
428         daemons/ganeti-rapi \
429         scripts/gnt-backup \
430         scripts/gnt-cluster \
431         scripts/gnt-debug \
432         scripts/gnt-group \
433         scripts/gnt-instance \
434         scripts/gnt-job \
435         scripts/gnt-node \
436         scripts/gnt-os
437
438 PYTHON_BOOTSTRAP = \
439         $(PYTHON_BOOTSTRAP_SBIN) \
440         tools/ensure-dirs
441
442 qa_scripts = \
443         qa/ganeti-qa.py \
444         qa/qa_cluster.py \
445         qa/qa_config.py \
446         qa/qa_daemon.py \
447         qa/qa_env.py \
448         qa/qa_error.py \
449         qa/qa_instance.py \
450         qa/qa_node.py \
451         qa/qa_os.py \
452         qa/qa_rapi.py \
453         qa/qa_tags.py \
454         qa/qa_utils.py
455
456 bin_SCRIPTS =
457 if WANT_HTOOLS
458 bin_SCRIPTS += $(filter-out htools/hail,$(HS_PROGS))
459 install-exec-hook:
460         @mkdir_p@ $(DESTDIR)$(iallocatorsdir)
461 # FIXME: this is a hardcoded logic, instead of auto-resolving
462         $(LN_S) -f ../../../bin/htools \
463                    $(DESTDIR)$(iallocatorsdir)/hail
464         for role in $(HS_BIN_ROLES); do \
465                 $(LN_S) -f htools \
466                            $(DESTDIR)$(bindir)/$$role ; \
467         done
468 endif
469
470 $(HS_ALL_PROGS): %: %.hs $(HS_LIB_SRCS) $(HS_BUILT_SRCS) Makefile
471         @if [ -z "$(HTOOLS)" ]; then \
472           echo "Error: htools compilation disabled at configure time" 1>&2 ;\
473           exit 1; \
474         fi
475         @BINARY=$(@:htools/%=%); \
476         if [ "$BINARY" = "test" ] && [ -z "$(GHC_PKG_QUICKCHECK)" ]; then \
477           echo "Error: cannot run unittests without the QuickCheck library (see devnotes.rst)" 1>&2; \
478           exit 1; \
479         fi
480         BINARY=$(@:htools/%=%); $(GHC) --make \
481           $(HFLAGS) $(HEXTRA) \
482           $(HTOOLS_NOCURL) $(HTOOLS_PARALLEL3) \
483           -osuf $$BINARY.o -hisuf $$BINARY.hi $@
484
485 # for the htools/test binary, we need to enable profiling/coverage
486 htools/test: HEXTRA=-fhpc -Wwarn -fno-warn-missing-signatures \
487         -fno-warn-monomorphism-restriction -fno-warn-orphans \
488         -fno-warn-missing-methods -fno-warn-unused-imports
489
490 dist_sbin_SCRIPTS = \
491         tools/ganeti-listrunner
492
493 nodist_sbin_SCRIPTS = \
494         $(PYTHON_BOOTSTRAP_SBIN) \
495         daemons/ganeti-cleaner
496
497 dist_tools_PYTHON = \
498         tools/burnin \
499         tools/cfgshell \
500         tools/cfgupgrade \
501         tools/cfgupgrade12 \
502         tools/cluster-merge \
503         tools/lvmstrap \
504         tools/move-instance \
505         tools/setup-ssh \
506         tools/sanitize-config
507
508 dist_tools_SCRIPTS = \
509         $(dist_tools_PYTHON) \
510         tools/kvm-console-wrapper \
511         tools/xm-console-wrapper
512
513 pkglib_python_scripts = \
514         daemons/import-export \
515         tools/check-cert-expired
516
517 nodist_pkglib_python_scripts = \
518         tools/ensure-dirs
519
520 pkglib_SCRIPTS = \
521         daemons/daemon-util \
522         tools/kvm-ifup \
523         $(pkglib_python_scripts)
524
525 nodist_pkglib_SCRIPTS = \
526         $(nodist_pkglib_python_scripts)
527
528 EXTRA_DIST = \
529         NEWS \
530         UPGRADE \
531         epydoc.conf.in \
532         pylintrc \
533         autotools/build-bash-completion \
534         autotools/check-python-code \
535         autotools/check-man \
536         autotools/check-news \
537         autotools/check-tar \
538         autotools/check-version \
539         autotools/convert-constants \
540         autotools/docpp \
541         autotools/gen-coverage \
542         autotools/testrunner \
543         $(RUN_IN_TEMPDIR) \
544         daemons/daemon-util.in \
545         daemons/ganeti-cleaner.in \
546         $(pkglib_python_scripts) \
547         devel/upload.in \
548         tools/kvm-ifup.in \
549         $(docdot) \
550         $(docpng) \
551         $(docrst) \
552         doc/conf.py \
553         doc/html \
554         doc/examples/ganeti.initd.in \
555         doc/examples/ganeti-kvm-poweroff.initd.in \
556         doc/examples/ganeti.cron.in \
557         doc/examples/gnt-config-backup.in \
558         doc/examples/ganeti.default \
559         doc/examples/ganeti.default-debug \
560         doc/examples/hooks/ethers \
561         doc/examples/hooks/ipsec.in \
562         doc/examples/gnt-debug/README \
563         doc/examples/gnt-debug/delay0.json \
564         doc/examples/gnt-debug/delay50.json \
565         test/testutils.py \
566         test/mocks.py \
567         $(dist_TESTS) \
568         $(TEST_FILES) \
569         man/footer.rst \
570         $(manrst) \
571         $(maninput) \
572         qa/qa-sample.json \
573         $(qa_scripts) \
574         $(HS_LIB_SRCS) $(HS_BUILT_SRCS_IN) \
575         $(HS_PROG_SRCS)
576
577 man_MANS = \
578         man/ganeti.7 \
579         man/ganeti-cleaner.8 \
580         man/ganeti-confd.8 \
581         man/ganeti-listrunner.8 \
582         man/ganeti-masterd.8 \
583         man/ganeti-noded.8 \
584         man/ganeti-os-interface.7 \
585         man/ganeti-rapi.8 \
586         man/ganeti-watcher.8 \
587         man/gnt-backup.8 \
588         man/gnt-cluster.8 \
589         man/gnt-debug.8 \
590         man/gnt-group.8 \
591         man/gnt-instance.8 \
592         man/gnt-job.8 \
593         man/gnt-node.8 \
594         man/gnt-os.8 \
595         man/hail.1 \
596         man/hbal.1 \
597         man/hscan.1 \
598         man/hspace.1 \
599         man/htools.1
600
601 manrst = $(patsubst %.1,%.rst,$(patsubst %.7,%.rst,$(patsubst %.8,%.rst,$(man_MANS))))
602 manhtml = $(patsubst %.rst,%.html,$(manrst))
603 mangen = $(patsubst %.rst,%.gen,$(manrst))
604 maninput = \
605         $(patsubst %.1,%.1.in,$(patsubst %.7,%.7.in,$(patsubst %.8,%.8.in,$(man_MANS)))) \
606         $(patsubst %.html,%.html.in,$(manhtml)) \
607         man/footer.man man/footer.html $(mangen)
608
609 TEST_FILES = \
610         test/data/bdev-drbd-8.0.txt \
611         test/data/bdev-drbd-8.3.txt \
612         test/data/bdev-drbd-disk.txt \
613         test/data/bdev-drbd-net-ip4.txt \
614         test/data/bdev-drbd-net-ip6.txt \
615         test/data/cert1.pem \
616         test/data/ip-addr-show-dummy0.txt \
617         test/data/ip-addr-show-lo-ipv4.txt \
618         test/data/ip-addr-show-lo-ipv6.txt \
619         test/data/ip-addr-show-lo-oneline-ipv4.txt \
620         test/data/ip-addr-show-lo-oneline-ipv6.txt \
621         test/data/ip-addr-show-lo-oneline.txt \
622         test/data/ip-addr-show-lo.txt \
623         test/data/proc_drbd8.txt \
624         test/data/proc_drbd80-emptyline.txt \
625         test/data/proc_drbd83.txt \
626         test/data/sys_drbd_usermode_helper.txt \
627         test/import-export_unittest-helper
628
629 python_tests = \
630         test/ganeti.asyncnotifier_unittest.py \
631         test/ganeti.backend_unittest.py \
632         test/ganeti.bdev_unittest.py \
633         test/ganeti.cli_unittest.py \
634         test/ganeti.client.gnt_cluster_unittest.py \
635         test/ganeti.client.gnt_instance_unittest.py \
636         test/ganeti.daemon_unittest.py \
637         test/ganeti.cmdlib_unittest.py \
638         test/ganeti.compat_unittest.py \
639         test/ganeti.confd.client_unittest.py \
640         test/ganeti.config_unittest.py \
641         test/ganeti.constants_unittest.py \
642         test/ganeti.errors_unittest.py \
643         test/ganeti.hooks_unittest.py \
644         test/ganeti.ht_unittest.py \
645         test/ganeti.http_unittest.py \
646         test/ganeti.hypervisor_unittest.py \
647         test/ganeti.hypervisor.hv_chroot_unittest.py \
648         test/ganeti.hypervisor.hv_fake_unittest.py \
649         test/ganeti.hypervisor.hv_kvm_unittest.py \
650         test/ganeti.hypervisor.hv_lxc_unittest.py \
651         test/ganeti.hypervisor.hv_xen_unittest.py \
652         test/ganeti.impexpd_unittest.py \
653         test/ganeti.jqueue_unittest.py \
654         test/ganeti.locking_unittest.py \
655         test/ganeti.luxi_unittest.py \
656         test/ganeti.masterd.instance_unittest.py \
657         test/ganeti.mcpu_unittest.py \
658         test/ganeti.netutils_unittest.py \
659         test/ganeti.objects_unittest.py \
660         test/ganeti.opcodes_unittest.py \
661         test/ganeti.qlang_unittest.py \
662         test/ganeti.query_unittest.py \
663         test/ganeti.rapi.baserlib_unittest.py \
664         test/ganeti.rapi.client_unittest.py \
665         test/ganeti.rapi.resources_unittest.py \
666         test/ganeti.rapi.rlib2_unittest.py \
667         test/ganeti.rpc_unittest.py \
668         test/ganeti.runtime_unittest.py \
669         test/ganeti.serializer_unittest.py \
670         test/ganeti.ssh_unittest.py \
671         test/ganeti.tools.ensure_dirs_unittest.py \
672         test/ganeti.uidpool_unittest.py \
673         test/ganeti.utils.algo_unittest.py \
674         test/ganeti.utils.filelock_unittest.py \
675         test/ganeti.utils.hash_unittest.py \
676         test/ganeti.utils.io_unittest.py \
677         test/ganeti.utils.log_unittest.py \
678         test/ganeti.utils.mlock_unittest.py \
679         test/ganeti.utils.nodesetup_unittest.py \
680         test/ganeti.utils.process_unittest.py \
681         test/ganeti.utils.retry_unittest.py \
682         test/ganeti.utils.text_unittest.py \
683         test/ganeti.utils.wrapper_unittest.py \
684         test/ganeti.utils.x509_unittest.py \
685         test/ganeti.utils_unittest.py \
686         test/ganeti.workerpool_unittest.py \
687         test/cfgupgrade_unittest.py \
688         test/docs_unittest.py \
689         test/tempfile_fork_unittest.py
690
691 haskell_tests = htools/test
692
693 dist_TESTS = \
694         test/check-cert-expired_unittest.bash \
695         test/daemon-util_unittest.bash \
696         test/ganeti-cleaner_unittest.bash \
697         test/import-export_unittest.bash \
698         $(python_tests)
699
700 nodist_TESTS =
701 if WANT_HTOOLSTESTS
702 nodist_TESTS += $(haskell_tests)
703 endif
704
705 TESTS = $(dist_TESTS) $(nodist_TESTS)
706
707 # Environment for all tests
708 PLAIN_TESTS_ENVIRONMENT = \
709         PYTHONPATH=. TOP_SRCDIR=$(abs_top_srcdir) PYTHON=$(PYTHON) $(RUN_IN_TEMPDIR)
710
711 # Environment for tests run by automake
712 TESTS_ENVIRONMENT = \
713         $(PLAIN_TESTS_ENVIRONMENT) $(abs_top_srcdir)/autotools/testrunner
714
715 all_python_code = \
716         $(dist_sbin_SCRIPTS) \
717         $(dist_tools_PYTHON) \
718         $(pkglib_python_scripts) \
719         $(nodist_pkglib_python_scripts) \
720         $(python_tests) \
721         $(pkgpython_PYTHON) \
722         $(client_PYTHON) \
723         $(hypervisor_PYTHON) \
724         $(rapi_PYTHON) \
725         $(server_PYTHON) \
726         $(pytools_PYTHON) \
727         $(http_PYTHON) \
728         $(confd_PYTHON) \
729         $(masterd_PYTHON) \
730         $(impexpd_PYTHON) \
731         $(utils_PYTHON) \
732         $(watcher_PYTHON) \
733         $(noinst_PYTHON) \
734         $(qa_scripts)
735
736 srclink_files = \
737         man/footer.rst \
738         test/check-cert-expired_unittest.bash \
739         test/daemon-util_unittest.bash \
740         test/ganeti-cleaner_unittest.bash \
741         test/import-export_unittest.bash \
742         $(all_python_code) \
743         $(HS_LIB_SRCS) $(HS_PROG_SRCS)
744
745 check_python_code = \
746         $(BUILD_BASH_COMPLETION) \
747         $(DOCPP) \
748         $(all_python_code)
749
750 lint_python_code = \
751         ganeti \
752         ganeti/http/server.py \
753         $(dist_sbin_SCRIPTS) \
754         $(dist_tools_PYTHON) \
755         $(pkglib_python_scripts) \
756         $(BUILD_BASH_COMPLETION) \
757         $(DOCPP) \
758         $(PYTHON_BOOTSTRAP)
759
760 test/daemon-util_unittest.bash: daemons/daemon-util
761
762 test/ganeti-cleaner_unittest.bash: daemons/ganeti-cleaner
763
764 tools/kvm-ifup: tools/kvm-ifup.in $(REPLACE_VARS_SED)
765         sed -f $(REPLACE_VARS_SED) < $< > $@
766         chmod +x $@
767
768 devel/upload: devel/upload.in $(REPLACE_VARS_SED)
769         sed -f $(REPLACE_VARS_SED) < $< > $@
770         chmod u+x $@
771
772 daemons/%: daemons/%.in $(REPLACE_VARS_SED)
773         sed -f $(REPLACE_VARS_SED) < $< > $@
774         chmod +x $@
775
776 doc/examples/%: doc/examples/%.in $(REPLACE_VARS_SED)
777         sed -f $(REPLACE_VARS_SED) < $< > $@
778
779 doc/examples/hooks/%: doc/examples/hooks/%.in $(REPLACE_VARS_SED)
780         sed -f $(REPLACE_VARS_SED) < $< > $@
781
782 doc/examples/bash_completion: $(BUILD_BASH_COMPLETION) $(RUN_IN_TEMPDIR) \
783         lib/cli.py $(gnt_scripts) $(client_PYTHON) tools/burnin
784         PYTHONPATH=. $(RUN_IN_TEMPDIR) $(CURDIR)/$(BUILD_BASH_COMPLETION) > $@
785
786 doc/%.png: doc/%.dot
787         @test -n "$(DOT)" || { echo 'dot' not found during configure; exit 1; }
788         $(DOT) -Tpng -o $@ $<
789
790 man/footer.man: man/footer.rst
791         @test -n "$(PANDOC)" || \
792           { echo 'pandoc' not found during configure; exit 1; }
793         $(PANDOC) -f rst -t man -o $@ $<
794
795 man/footer.html: man/footer.rst
796         @test -n "$(PANDOC)" || \
797           { echo 'pandoc' not found during configure; exit 1; }
798         $(PANDOC) -f rst -t html -o $@ $<
799
800 man/%.gen: man/%.rst lib/query.py lib/build/sphinx_ext.py
801         PYTHONPATH=. $(RUN_IN_TEMPDIR) $(CURDIR)/$(DOCPP) < $< > $@
802
803 man/%.7.in man/%.8.in man/%.1.in: man/%.gen man/footer.man
804         @test -n "$(PANDOC)" || \
805           { echo 'pandoc' not found during configure; exit 1; }
806         set -o pipefail ; \
807         $(PANDOC) -s -f rst -t man -A man/footer.man $< | \
808           sed -e 's/\\@/@/g' > $@
809         if test -n "$(MAN_HAS_WARNINGS)"; then $(CHECK_MAN) $@; fi
810
811 man/%.html.in: man/%.gen man/footer.html
812         @test -n "$(PANDOC)" || \
813           { echo 'pandoc' not found during configure; exit 1; }
814         set -o pipefail ; \
815         $(PANDOC) -s -f rst -t html -A man/footer.html $< | \
816           sed -e 's/\\@/@/g' > $@
817
818 man/%.1: man/%.1.in $(REPLACE_VARS_SED)
819         sed -f $(REPLACE_VARS_SED) < $< > $@
820
821 man/%.7: man/%.7.in $(REPLACE_VARS_SED)
822         sed -f $(REPLACE_VARS_SED) < $< > $@
823
824 man/%.8: man/%.8.in $(REPLACE_VARS_SED)
825         sed -f $(REPLACE_VARS_SED) < $< > $@
826
827 man/%.html: man/%.html.in $(REPLACE_VARS_SED)
828         sed -f $(REPLACE_VARS_SED) < $< > $@
829
830 epydoc.conf: epydoc.conf.in Makefile
831         sed -e 's#@MODULES@#$(strip $(lint_python_code))#g' < $< > $@
832
833 vcs-version:
834         if test -d .git; then \
835           git describe > $@; \
836         elif test ! -f $@ ; then \
837           echo "Cannot auto-generate $@ file"; exit 1; \
838         fi
839
840 .PHONY: regen-vcs-version
841 regen-vcs-version:
842         set -e; \
843         cd $(srcdir); \
844         if test -d .git; then \
845           rm -f vcs-version; \
846           $(MAKE) vcs-version; \
847         fi
848
849 htools/Ganeti/HTools/Version.hs: htools/Ganeti/HTools/Version.hs.in vcs-version
850         set -e; \
851         VCSVER=`cat $(abs_top_srcdir)/vcs-version`; \
852         sed -e "s/%ver%/$$VCSVER/" < $< > $@
853
854 htools/Ganeti/Constants.hs: htools/Ganeti/Constants.hs.in \
855         lib/constants.py lib/_autoconf.py $(CONVERT_CONSTANTS)
856         set -e; \
857         { cat $< ; PYTHONPATH=. $(CONVERT_CONSTANTS); } > $@
858
859 lib/_autoconf.py: Makefile | lib/.dir
860         set -e; \
861         { echo '# This file is automatically generated, do not edit!'; \
862           echo '#'; \
863           echo ''; \
864           echo '"""Build-time configuration for Ganeti.'; \
865           echo '';\
866           echo 'This file is autogenerated by the build process.'; \
867           echo 'For any changes you need to re-run ./configure (and'; \
868           echo 'not edit by hand).'; \
869           echo ''; \
870           echo '"""'; \
871           echo ''; \
872           echo '# pylint: disable-msg=C0301,C0324'; \
873           echo '# because this is autogenerated, we do not want'; \
874           echo '# style warnings' ; \
875           echo ''; \
876           echo "PACKAGE_VERSION = '$(PACKAGE_VERSION)'"; \
877           echo "VERSION_MAJOR = '$(VERSION_MAJOR)'"; \
878           echo "VERSION_MINOR = '$(VERSION_MINOR)'"; \
879           echo "VERSION_REVISION = '$(VERSION_REVISION)'"; \
880           echo "VERSION_SUFFIX = '$(VERSION_SUFFIX)'"; \
881           echo "VERSION_FULL = '$(VERSION_FULL)'"; \
882           echo "LOCALSTATEDIR = '$(localstatedir)'"; \
883           echo "SYSCONFDIR = '$(sysconfdir)'"; \
884           echo "SSH_CONFIG_DIR = '$(SSH_CONFIG_DIR)'"; \
885           echo "EXPORT_DIR = '$(EXPORT_DIR)'"; \
886           echo "OS_SEARCH_PATH = [$(OS_SEARCH_PATH)]"; \
887           echo "XEN_BOOTLOADER = '$(XEN_BOOTLOADER)'"; \
888           echo "XEN_KERNEL = '$(XEN_KERNEL)'"; \
889           echo "XEN_INITRD = '$(XEN_INITRD)'"; \
890           echo "FILE_STORAGE_DIR = '$(FILE_STORAGE_DIR)'"; \
891           echo "ENABLE_FILE_STORAGE = $(ENABLE_FILE_STORAGE)"; \
892           echo "SHARED_FILE_STORAGE_DIR = '$(SHARED_FILE_STORAGE_DIR)'"; \
893           echo "ENABLE_SHARED_FILE_STORAGE = $(ENABLE_SHARED_FILE_STORAGE)"; \
894           echo "IALLOCATOR_SEARCH_PATH = [$(IALLOCATOR_SEARCH_PATH)]"; \
895           echo "KVM_PATH = '$(KVM_PATH)'"; \
896           echo "IP_PATH = '$(IP_PATH)'"; \
897           echo "SOCAT_PATH = '$(SOCAT)'"; \
898           echo "SOCAT_USE_ESCAPE = $(SOCAT_USE_ESCAPE)"; \
899           echo "SOCAT_USE_COMPRESS = $(SOCAT_USE_COMPRESS)"; \
900           echo "LVM_STRIPECOUNT = $(LVM_STRIPECOUNT)"; \
901           echo "TOOLSDIR = '$(toolsdir)'"; \
902           echo "GNT_SCRIPTS = [$(foreach i,$(notdir $(gnt_scripts)),'$(i)',)]"; \
903           echo "PKGLIBDIR = '$(pkglibdir)'"; \
904           echo "DRBD_BARRIERS = $(DRBD_BARRIERS)"; \
905           echo "SYSLOG_USAGE = '$(SYSLOG_USAGE)'"; \
906           echo "DAEMONS_GROUP = '$(DAEMONS_GROUP)'"; \
907           echo "ADMIN_GROUP = '$(ADMIN_GROUP)'"; \
908           echo "MASTERD_USER = '$(MASTERD_USER)'"; \
909           echo "MASTERD_GROUP = '$(MASTERD_GROUP)'"; \
910           echo "RAPI_USER = '$(RAPI_USER)'"; \
911           echo "RAPI_GROUP = '$(RAPI_GROUP)'"; \
912           echo "CONFD_USER = '$(CONFD_USER)'"; \
913           echo "CONFD_GROUP = '$(CONFD_GROUP)'"; \
914           echo "NODED_USER = '$(NODED_USER)'"; \
915           echo "NODED_GROUP = '$(NODED_GROUP)'"; \
916           echo "DISK_SEPARATOR = '$(DISK_SEPARATOR)'"; \
917           if [ "$(HTOOLS)" ]; then \
918             echo "HTOOLS = True"; \
919           else \
920             echo "HTOOLS = False"; \
921           fi; \
922         } > $@
923
924 lib/_vcsversion.py: Makefile vcs-version | lib/.dir
925         set -e; \
926         VCSVER=`cat $(abs_top_srcdir)/vcs-version`; \
927         { echo '# This file is automatically generated, do not edit!'; \
928           echo '#'; \
929           echo ''; \
930           echo '"""Build-time VCS version number for Ganeti.'; \
931           echo '';\
932           echo 'This file is autogenerated by the build process.'; \
933           echo 'For any changes you need to re-run ./configure (and'; \
934           echo 'not edit by hand).'; \
935           echo ''; \
936           echo '"""'; \
937           echo ''; \
938           echo '# pylint: disable-msg=C0301,C0324'; \
939           echo '# because this is autogenerated, we do not want'; \
940           echo '# style warnings' ; \
941           echo ''; \
942           echo "VCS_VERSION = '$$VCSVER'"; \
943         } > $@
944
945 $(REPLACE_VARS_SED): Makefile
946         set -e; \
947         { echo 's#@PREFIX@#$(prefix)#g'; \
948           echo 's#@SYSCONFDIR@#$(sysconfdir)#g'; \
949           echo 's#@LOCALSTATEDIR@#$(localstatedir)#g'; \
950           echo 's#@BINDIR@#$(bindir)#g'; \
951           echo 's#@SBINDIR@#$(sbindir)#g'; \
952           echo 's#@GANETI_VERSION@#$(PACKAGE_VERSION)#g'; \
953           echo 's#@CUSTOM_XEN_BOOTLOADER@#$(XEN_BOOTLOADER)#g'; \
954           echo 's#@CUSTOM_XEN_KERNEL@#$(XEN_KERNEL)#g'; \
955           echo 's#@CUSTOM_XEN_INITRD@#$(XEN_INITRD)#g'; \
956           echo 's#@CUSTOM_IALLOCATOR_SEARCH_PATH@#$(IALLOCATOR_SEARCH_PATH)#g'; \
957           echo 's#@CUSTOM_EXPORT_DIR@#$(EXPORT_DIR)#g'; \
958           echo 's#@RPL_FILE_STORAGE_DIR@#$(FILE_STORAGE_DIR)#g'; \
959           echo 's#@RPL_SSH_INITD_SCRIPT@#$(SSH_INITD_SCRIPT)#g'; \
960           echo 's#@PKGLIBDIR@#$(pkglibdir)#g'; \
961           echo 's#@GNTMASTERUSER@#$(MASTERD_USER)#g'; \
962           echo 's#@GNTRAPIUSER@#$(RAPI_USER)#g'; \
963           echo 's#@GNTCONFDUSER@#$(CONFD_USER)#g'; \
964           echo 's#@GNTNODEDUSER@#$(NODED_USER)#g'; \
965           echo 's#@GNTRAPIGROUP@#$(RAPI_GROUP)#g'; \
966           echo 's#@GNTADMINGROUP@#$(ADMIN_GROUP)#g'; \
967           echo 's#@GNTCONFDGROUP@#$(CONFD_GROUP)#g'; \
968           echo 's#@GNTMASTERDGROUP@#$(MASTERD_GROUP)#g'; \
969           echo 's#@GNTDAEMONSGROUP@#$(DAEMONS_GROUP)#g'; \
970         } > $@
971
972 # Using deferred evaluation
973 daemons/ganeti-%: MODULE = ganeti.server.$(patsubst ganeti-%,%,$(notdir $@))
974 daemons/ganeti-watcher: MODULE = ganeti.watcher
975 scripts/%: MODULE = ganeti.client.$(subst -,_,$(notdir $@))
976 tools/ensure-dirs: MODULE = ganeti.tools.ensure_dirs
977
978 $(PYTHON_BOOTSTRAP): Makefile | $(all_dirfiles)
979         test -n "$(MODULE)" || { echo Missing module; exit 1; }
980         set -e; \
981         { echo '#!/usr/bin/python'; \
982           echo '# This file is automatically generated, do not edit!'; \
983           echo "# Edit $(MODULE) instead."; \
984           echo; \
985           echo '"""Bootstrap script for L{$(MODULE)}"""'; \
986           echo; \
987           echo '# pylint: disable-msg=C0103'; \
988           echo '# C0103: Invalid name'; \
989           echo; \
990           echo 'import sys'; \
991           echo 'import $(MODULE) as main'; \
992           echo; \
993           echo '# Temporarily alias commands until bash completion'; \
994           echo '# generator is changed'; \
995           echo 'if hasattr(main, "commands"):'; \
996           echo '  commands = main.commands # pylint: disable-msg=E1101'; \
997           echo 'if hasattr(main, "aliases"):'; \
998           echo '  aliases = main.aliases # pylint: disable-msg=E1101'; \
999           echo; \
1000           echo 'if __name__ == "__main__":'; \
1001           echo '  sys.exit(main.Main())'; \
1002         } > $@
1003         chmod u+x $@
1004
1005 # We need to create symlinks because "make distcheck" will not install Python
1006 # files when building.
1007 stamp-srclinks: Makefile | $(all_dirfiles)
1008         set -e; \
1009         for i in $(srclink_files); do \
1010                 if test ! -f $$i -a -f $(abs_top_srcdir)/$$i; then \
1011                         $(LN_S) $(abs_top_srcdir)/$$i $$i; \
1012                 fi; \
1013         done
1014         touch $@
1015
1016 .PHONY: ganeti
1017 ganeti:
1018         cd $(top_builddir) && test -h "$@" || { rm -f $@ && $(LN_S) lib $@; }
1019
1020 .PHONY: check-dirs
1021 check-dirs: $(BUILT_SOURCES)
1022         @set -e; \
1023         find . -type d \( \( -name . \) -o \( \
1024                 -name .git -o \
1025                 -name autom4te.cache \
1026                 \) -prune -o -print \) | { \
1027                 error=; \
1028                 while read dir; do \
1029                         case "$$dir" in \
1030                                 $(strip $(patsubst %,(./%) ;;,$(DIRCHECK_EXCLUDE) $(DIRS))) \
1031                                 *) error=1; echo "Directory $$dir not listed in Makefile" >&2 ;; \
1032                         esac; \
1033                 done; \
1034                 for dir in $(DIRS); do \
1035                         if ! test -d "$$dir"; then \
1036                                 echo "Directory $$dir listed in DIRS does not exist" >&2; \
1037                                 error=1; \
1038                         fi \
1039                 done; \
1040                 if test -n "$$error"; then exit 1; else exit 0; fi; \
1041         }
1042
1043 check-local: check-dirs
1044         $(CHECK_PYTHON_CODE) $(check_python_code)
1045         $(CHECK_VERSION) $(VERSION) $(top_srcdir)/NEWS
1046         $(CHECK_NEWS) < $(top_srcdir)/NEWS
1047         expver=$(VERSION_MAJOR).$(VERSION_MINOR); \
1048         if test "`head -n 1 $(top_srcdir)/README`" != "Ganeti $$expver"; then \
1049                 echo "Incorrect version in README, expected $$expver"; \
1050                 exit 1; \
1051         fi; \
1052         for file in doc/iallocator.rst doc/hooks.rst; do \
1053                 if test "`sed -ne '4 p' $(top_srcdir)/$$file`" != \
1054                         "Documents Ganeti version $$expver"; then \
1055                         echo "Incorrect version in $$file, expected $$expver"; \
1056                         exit 1; \
1057                 fi; \
1058         done
1059
1060 .PHONY: hs-check
1061 hs-check: htools/test
1062         @rm -f test.tix
1063         ./htools/test
1064
1065 .PHONY: lint
1066 lint: $(BUILT_SOURCES)
1067         @test -n "$(PYLINT)" || { echo 'pylint' not found during configure; exit 1; }
1068         $(PYLINT) $(LINT_OPTS) $(lint_python_code)
1069         cd $(top_srcdir)/qa && \
1070           PYTHONPATH=$(abs_top_srcdir) $(PYLINT) $(LINT_OPTS) \
1071           --rcfile  ../pylintrc $(patsubst qa/%.py,%,$(qa_scripts))
1072
1073 .PHONY: hlint
1074 hlint: $(HS_BUILT_SRCS)
1075         if tty -s; then C="-c"; else C=""; fi; \
1076         hlint --report=doc/hs-lint.html $$C htools
1077
1078 # a dist hook rule for updating the vcs-version file; this is
1079 # hardcoded due to where it needs to build the file...
1080 dist-hook:
1081         $(MAKE) regen-vcs-version && \
1082         rm -f $(top_distdir)/vcs-version && \
1083         cp -p $(srcdir)/vcs-version $(top_distdir)
1084
1085 # a distcheck hook rule for catching revision control directories
1086 distcheck-hook:
1087         if find $(top_distdir) -name .svn -or -name .git | grep .; then \
1088                 echo "Found revision control files in final archive." 1>&2; \
1089                 exit 1; \
1090         fi
1091         if find $(top_distdir) -name '*.py[co]' | grep .; then \
1092                 echo "Found Python byte code in final archive." 1>&2; \
1093                 exit 1; \
1094         fi
1095         if find $(top_distdir) -name '*~' | grep .; then \
1096                 echo "Found backup files in final archive." 1>&2; \
1097                 exit 1; \
1098         fi
1099 # Empty files or directories should not be distributed. They can cause
1100 # unnecessary warnings for packagers. Directories used by automake during
1101 # distcheck must be excluded.
1102         if find $(top_distdir) -empty -and -not \( \
1103                         -path $(top_distdir)/_build -or \
1104                         -path $(top_distdir)/_inst \) | grep .; then \
1105                 echo "Found empty files or directories in final archive." 1>&2; \
1106                 exit 1; \
1107         fi
1108         if test -n "$(BUILD_RELEASE)" && \
1109            grep -n -H -E '^\*.*unreleased' $(top_distdir)/NEWS; then \
1110                 echo "Found unreleased version in NEWS." >&2; \
1111                 exit 1; \
1112         fi
1113
1114 # When building a release, stricter checks should be used
1115 distcheck-release dist-release: export BUILD_RELEASE = 1
1116 distcheck-release: distcheck
1117
1118 dist-release: dist
1119         set -e; \
1120         for i in $(DIST_ARCHIVES); do \
1121                 echo -n "Checking $$i ... "; \
1122                 autotools/check-tar < $$i; \
1123                 echo OK; \
1124         done
1125
1126 install-exec-local:
1127         @mkdir_p@ "$(DESTDIR)${localstatedir}/lib/ganeti" \
1128           "$(DESTDIR)${localstatedir}/log/ganeti" \
1129           "$(DESTDIR)${localstatedir}/run/ganeti"
1130
1131 # To avoid conflicts between directory names and other targets, a file inside
1132 # the directory is used to ensure its existence.
1133 %.dir:
1134         @mkdir_p@ $* && touch $@
1135
1136 .PHONY: apidoc
1137 if WANT_HTOOLSAPIDOC
1138 apidoc: py-apidoc hs-apidoc
1139 else
1140 apidoc: py-apidoc
1141 endif
1142
1143 .PHONY: py-apidoc
1144 py-apidoc: epydoc.conf $(RUN_IN_TEMPDIR) $(BUILT_SOURCES)
1145         $(RUN_IN_TEMPDIR) epydoc -v \
1146                 --conf $(CURDIR)/epydoc.conf \
1147                 --output $(CURDIR)/$(APIDOC_PY_DIR)
1148
1149 .PHONY: hs-apidoc
1150 hs-apidoc: $(HS_BUILT_SRCS)
1151         @test -n "$(HSCOLOUR)" || \
1152             { echo 'HsColour' not found during configure; exit 1; }
1153         @test -n "$(HADDOCK)" || \
1154             { echo 'haddock' not found during configure; exit 1; }
1155         rm -rf $(APIDOC_HS_DIR)/*
1156         @mkdir_p@ $(APIDOC_HS_DIR)/Ganeti/HTools/Program
1157         $(HSCOLOUR) -print-css > $(APIDOC_HS_DIR)/Ganeti/hscolour.css
1158         ln -s ../hscolour.css $(APIDOC_HS_DIR)/Ganeti/HTools/hscolour.css
1159         set -e ; \
1160         cd htools; \
1161         if [ "$(HTOOLS_NOCURL)" ]; \
1162         then OPTGHC="--optghc=$(HTOOLS_NOCURL)"; \
1163         else OPTGHC=""; \
1164         fi; \
1165         if [ "$(HTOOLS_PARALLEL3)" ]; \
1166         then OPTGHC="$$OPTGHC --optghc=$(HTOOLS_PARALLEL3)"; \
1167         fi; \
1168         RELSRCS="$(HS_LIB_SRCS:htools/%=%)  $(HS_BUILT_SRCS:htools/%=%)"; \
1169         for file in $$RELSRCS; do \
1170                 hfile=`echo $$file|sed 's/\\.hs$$//'`.html; \
1171                 $(HSCOLOUR) -css -anchor $$file > ../$(APIDOC_HS_DIR)/$$hfile ; \
1172         done ; \
1173         $(HADDOCK) --odir ../$(APIDOC_HS_DIR) --html --ignore-all-exports -w \
1174                 -t ganeti-htools -p haddock-prologue \
1175                 --source-module="%{MODULE/.//}.html" \
1176                 --source-entity="%{MODULE/.//}.html#%{NAME}" \
1177                 $$OPTGHC \
1178                 $(filter-out Ganeti/HTools/ExtLoader.hs,$(HS_LIB_SRCS:htools/%=%))
1179
1180 .PHONY: TAGS
1181 TAGS: $(BUILT_SOURCES)
1182         rm -f TAGS
1183         find . -path './lib/*.py' -o -path './scripts/gnt-*' -o \
1184           -path './daemons/ganeti-*' -o -path './tools/*' -o \
1185           -path './qa/*.py' | \
1186           etags -l python -
1187
1188 .PHONY: coverage
1189 if WANT_HTOOLS
1190 coverage: py-coverage hs-coverage
1191 else
1192 coverage: py-coverage
1193 endif
1194
1195 .PHONY: py-coverage
1196 py-coverage: $(BUILT_SOURCES) $(python_tests)
1197         set -e; \
1198         COVERAGE_FILE=$(CURDIR)/$(COVERAGE_PY_DIR)/data \
1199         TEXT_COVERAGE=$(CURDIR)/$(COVERAGE_PY_DIR)/report.txt \
1200         HTML_COVERAGE=$(CURDIR)/$(COVERAGE_PY_DIR) \
1201         $(PLAIN_TESTS_ENVIRONMENT) $(abs_top_srcdir)/autotools/gen-coverage \
1202         $(python_tests)
1203
1204 .PHONY: hs-coverage
1205 hs-coverage: $(haskell_tests)
1206         cd htools && rm -f *.tix *.mix && ./test
1207         @mkdir_p@ $(COVERAGE_HS_DIR)
1208         hpc markup --destdir=$(COVERAGE_HS_DIR) htools/test $(HPCEXCL)
1209         hpc report htools/test $(HPCEXCL)
1210         ln -sf hpc_index.html $(COVERAGE_HS_DIR)/index.html
1211
1212 # Special "kind-of-QA" target for htools, needs special setup (all
1213 # tools compiled with -fhpc)
1214 .PHONY: live-test
1215 live-test: all
1216         set -e ; \
1217         cd htools; \
1218         rm -f .hpc; ln -s ../.hpc .hpc; \
1219         rm -f *.tix *.mix; \
1220         ./live-test.sh; \
1221         hpc sum --union $(HPCEXCL) $(addsuffix .tix,$(HS_PROGS:htools/%=%)) \
1222           --output=live-test.tix ; \
1223         @mkdir_p@ ../$(COVERAGE_HS_DIR) ; \
1224         hpc markup --destdir=../$(COVERAGE_HS_DIR) live-test \
1225                 --srcdir=.. $(HPCEXCL) ; \
1226         hpc report --srcdir=.. live-test $(HPCEXCL)
1227
1228 commit-check: distcheck lint apidoc
1229
1230 -include ./Makefile.local
1231
1232 # vim: set noet :